//================================================================================================
//                                  cIotModule body
//================================================================================================

bool cIotModule::Initialized = false;

bool cIotModule::initialize(void *pContext, pWiFiEventHandler WiFiEventHandler)
{
  if (!Initialized)
  {
    esp_log_level_set("*", ESP_LOG_VERBOSE); //  for all modules verbose
    esp_log_level_set("wifi", ESP_LOG_WARN);  //  for wifi module warning
    esp_log_level_set(pTAG, ESP_LOG_INFO);  //  for this module info

    //  ESP_LOG_LEVEL_LOCAL(ESP_LOG_VERBOSE, pTAG, "Verbose log");
    //  ESP_LOG_LEVEL_LOCAL(ESP_LOG_VERBOSE, pTAG, "Debug log");
    //  ESP_LOG_LEVEL_LOCAL(ESP_LOG_INFO, pTAG, "Info log");
    //  ESP_LOG_LEVEL_LOCAL(ESP_LOG_WARN, pTAG, "Warn log");
    //  ESP_LOG_LEVEL_LOCAL(ESP_LOG_ERROR, pTAG, "Error log");

    ESP_LOG_LEVEL_LOCAL(ESP_LOG_INFO, pTAG, "%18s %4d - initializing", __FILENAME__, __LINE__);

    //  IotModuleCom object allocation
    IotModuleCom.Initialize(pContext, WiFiEventHandler);
    Initialized = true;
  }
  return !Initialized;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//                                 User program interface functions
///////////////////////////////////////////////////////////////////////////////////////////////////////

void cIotModule::genericWrite8 (const uint8_t PinName, const uint8_t Value)
{
  if (!Initialized) return;
  IotModuleCom.IotModuleApp.GenericWrite8(PinName, Value);
}

void cIotModule::genericWrite16(const uint8_t PinName, const uint16_t Value)
{
  if (!Initialized) return;
  IotModuleCom.IotModuleApp.GenericWrite16(PinName, Value);
}

void cIotModule::genericWrite24(const uint8_t PinName, const uint32_t Value)
{
  if (!Initialized) return;
  IotModuleCom.IotModuleApp.GenericWrite24(PinName, Value);
}

void cIotModule::genericWriteFloat(const uint8_t PinName, const float Value)
{
  if (!Initialized) return;
  IotModuleCom.IotModuleApp.GenericWriteFloat(PinName, Value);
}

uint8_t cIotModule::genericRead8 (const uint8_t PinName)
{
  return Initialized ? IotModuleCom.IotModuleApp.GenericRead8(PinName) : 0;
}

uint16_t cIotModule::genericRead16(const uint8_t PinName)
{
  return Initialized ? IotModuleCom.IotModuleApp.GenericRead16(PinName) : 0;
}

uint32_t cIotModule::genericRead24(const uint8_t PinName)
{
  return Initialized ? IotModuleCom.IotModuleApp.GenericRead24(PinName) : 0;
}

float cIotModule::genericReadFloat(const uint8_t PinName)
{
  return Initialized ? IotModuleCom.IotModuleApp.GenericReadFloat(PinName) : 0.0f;
}

