#ifndef IotModuleSetup_h
#define IotModuleSetup_h
//==============================================================================================================================================

#define IOTMODULE_LOG_LEVEL ESP_LOG_NONE  // ESP_LOG_NONE or ESP_LOG_VERBOSE to log debug messages with the serial monitor

//==============================================================================================================================================

#define IOTMODULE_PINOUT_TYPE 1   //  0 = ESP32-WROOM-32 / 1 (default) = ESP32-PICO-KIT V4 / 2 = ESP32-TTGO T7 v1.0 / 3 = ESP32-TTGO T7 v1.3
#define IOTMODULE_INOUT_PINS 99   //  0 to 99  (99 = all available phisical pins, max 26 or 28, it depends on module type) 
#define IOTMODULE_ADC24_PINS 0    //  0 to 16  (0 Adc24 module disabled, 1 to 16 Adc24 module enabled with 1 to 16 channels pins)
#define IOTMODULE_GENERIC_PINS 0  //  0 to 20  (0 normally)

//==============================================================================================================================================

//(see insider help at https://lowpower.world/theremino)

#define IOTMODULE_WIFI_MODE        "STATION"
#define IOTMODULE_WIFI_ASSOC       "       STATION                     STATION                     STATION                    SOFTAP         "     
#define IOTMODULE_WIFI_SSID        "        ssid1                       ssid2                       ssid3                      ssid4         "
#define IOTMODULE_WIFI_PASSWORD    "       pwd12345                    pwd12345                    pwd12345                   pwd12345       "
#define IOTMODULE_IP_MODE          "        DHCP                        DHCP                       STATIC                      DHCP          "
#define IOTMODULE_IP_IP            "          -                           -                     192.168.11.1                     -           "
#define IOTMODULE_IP_NETWORK       "          -                           -                     255.255.255.0                    -           "
#define IOTMODULE_IP_GATEWAY       "          -                           -                    192.168.11.254                    -           "
#define IOTMODULE_IP_DNS           "          -                           -                    192.168.11.254                    -           "

//  Uncomment and set the pin number to use as "wifi mode pin" (default -1, not used)
//#define IOTMODULE_WIFI_MODE_PIN    -1

//  Uncomment and set the WiFi channel number : 1 (default) to 13 (only relevant in SoftAP mode)
//#define IOTMODULE_WIFI_CHANNEL 1

//  Uncomment and set the WiFi TX power index : 10 (default) to 0
//  10=19.5dBm, 9=19dBm, 8=18.5dBm, 7=17dBm, 6=15dBm, 5=13dBm, 4=11dBm, 3=8.5dBm, 2=7dBm, 1=5dBm, 0=2dBm
//#define IOTMODULE_WIFI_TX_POWER_INDEX 10

//  Uncomment to change the space char in configuration
//#define IOTMODULE_SPACE_CHAR ' '

//==============================================================================================================================================

// Uncomment and adapt this line to use a different port number (default is 49153)
//#define IOTMODULE_UDP_PORT_NUMBER 49153  //  UDP port number for IotHAL communication

//==============================================================================================================================================

#define IOTMODULE_ENCODERS_TYPE 1               // 1 = Software encoders (x4) / 0 = Hard. encoders (x2)
#define IOTMODULE_FUOTA_ENABLE 1                // 1 = FUOTA enabled / 0 = FUOTA disabled 
#define IOTMODULE_ADC24_COMMUNICATION_SPEED 16  // 1 to 16 MHz (only relevant for the ADC24 board)
#define IOTMODULE_OUTPUT_WATCHDOG_ENABLE 1      // 1 = set all OUT to zero if communication is lost
#define IOTMODULE_WIFI_MODE_PIN -1              // -1 = disable / 0 or more = pin number for Station/SoftAP boot mode

//==============================================================================================================================================

//                                                          mm/min values are relative to 200 step/mm
//  IOTMODULE_STEPPER_TIMING = 8 :  320...307200 Hz - 92160 mm/min
//  IOTMODULE_STEPPER_TIMING = 7 :  160...153600 Hz - 46080 mm/min
//  IOTMODULE_STEPPER_TIMING = 6 :   80....76800 Hz - 23040 mm/min
//  IOTMODULE_STEPPER_TIMING = 5 :   40....38400 Hz - 11520 mm/min
//  IOTMODULE_STEPPER_TIMING = 4 :   20....19200 Hz -  5760 mm/min
//  IOTMODULE_STEPPER_TIMING = 3 :   10.....9600 Hz -  2880 mm/min
//  IOTMODULE_STEPPER_TIMING = 2 :    5.....4800 Hz -  1440 mm/min
//  IOTMODULE_STEPPER_TIMING = 1 :    3.....2400 Hz -   720 mm/min
//  IOTMODULE_STEPPER_TIMING = 0 :    2.....1200 Hz -   360 mm/min

#define IOTMODULE_STEPPER_TIMING 5

//==============================================================================================================================================

#endif
